<?php

/* Канал - https://t.me/swiftcms */
/* Автор - tiqix */
/* Тема - https://bym.guru/forum/topic/159786 */

function acn($initialText) { //Algorithm of a certain number
    
    $num1 = 1;
    $num2 = 5;
    
    // Шаг 1: Получаем начальный MD5 хеш текста
    $hash = md5($initialText);
    
    // Шаг 2: Извлекаем только цифры из хеша
    $digits = preg_replace('/[^0-9]/', '', $hash);
    
    // Если в хеше нет цифр, повторно хешируем сам хеш
    while (empty($digits)) {
        $hash = md5($hash);
        $digits = preg_replace('/[^0-9]/', '', $hash);
    }
    
    // Складываем все цифры вместе
    $sum = array_sum(str_split($digits));
    
    // Проверяем количество цифр в сумме и сводим к одной цифре, если нужно
    while ($sum >= 10) {
        $sum = array_sum(str_split((string)$sum));
    }
    
    // Переменная для отслеживания шагов
    $step = 1;
    
    // Проверяем, попадает ли сумма в диапазон от $num1 до $num2
    while ($sum < $num1 || $sum > $num2) {
        $diff = 10 - $sum;
        $newText = "$hash-$sum$diff-$step";
        
        // Вычисляем новый хеш
        $hash = md5($newText);
        $digits = preg_replace('/[^0-9]/', '', $hash);
        
        // Если в хеше нет цифр, повторно хешируем сам хеш
        while (empty($digits)) {
            $hash = md5($hash);
            $digits = preg_replace('/[^0-9]/', '', $hash);
        }
        
        $sum = array_sum(str_split($digits));
        while ($sum >= 10) {
            $sum = array_sum(str_split((string)$sum));
        }
        
        $step++;
        
        // Предотвращение бесконечного цикла
        if ($step > 100) {
            return "Лимит шагов";
        }
    }
    
    // Возвращаем только финальное число
    return $sum;
}
