<?php

/* Канал - https://t.me/swiftcms */
/* Автор - tiqix */
/* Тема - https://bym.guru/forum/topic/159786 */

require_once($_SERVER["DOCUMENT_ROOT"].'/swift/config.php');

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    
    $login = sanitize($_POST['login']);
    $password = $_POST['password'];

    $stmt = $pdo->prepare("SELECT id, password, token FROM users WHERE email = ? OR nick = ?");
    $stmt->execute([$login, $login]);
    $user = $stmt->fetch();

    if (!$user || !password_verify($password, $user['password'])) die("Невірні дані");
    setcookie("token", $user['token'], time() + 31536000, "/");
    header("Location: /");
}

require_once($_SERVER["DOCUMENT_ROOT"].'/swift/header.php');
?>
<div class="form">
    <div class="login_text">
        <div class="login_title">С возвращением 👋</div>
        Этот сайт работает на SwiftCMS.<br> Свободный код – свободный мир!
    </div>
    <form method="POST">
        <input type="text" name="login" placeholder="Email или Ник" required>
        <input type="password" name="password" placeholder="Пароль" required>
        <button type="submit">Ввойти</button>
    </form>
    <div class="pod_text">
        Нет аккаунта? <a href="/register.php">Зарегистрироваться</a>
    </div>
</div>
<?php

require_once($_SERVER["DOCUMENT_ROOT"].'/swift/footer.php');

?>