<?php

/* Канал - https://t.me/swiftcms */
/* Автор - tiqix */
/* Тема - https://bym.guru/forum/topic/159786 */

$title = 'SwiftCMS — Система для создания сайтов';
$descr = 'Свободный код – свободный мир!';
?>
<html>
    <head>
        <title><?=$title?></title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=1.0,user-scalable=1">
		<meta name="theme-color" content="#2E304D">
        <meta name="title" content="<?=$title?>" />
        <meta name="description" content="<?=$descr?>" />
        <meta property="og:type" content="website" />
        <meta property="og:url" content="<?php echo ($_SERVER['REQUEST_SCHEME'] ?? 'http') . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; ?>" />
        <meta property="og:title" content="<?=$title?>" />
        <meta property="og:description" content="<?=$descr?>" />
        <meta property="og:image" content="<?php echo ($_SERVER['REQUEST_SCHEME'] ?? 'http') . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; ?>/images/meta-tags.png" />
        <link rel="stylesheet" href="/static/styles.css?s=<?=mt_rand()?>">
        <link rel="stylesheet" href="/static/media.css?s=<?=mt_rand()?>">
        <link rel="icon" href="/static/favicon.ico" type="image/x-icon">
    </head>
    <body>
        <header>
            <div class="head">
                <img class="logo" src="/static/swiftlogo.svg">
                <div class="headAva">
                    <?php
                    if ($auth) {
                        echo '<a href="/profile.php?id='.$auth['id'].'"><img src="/static/latter.php?color='.acn($auth['id']).'&latter='.htmlspecialchars($auth['nick']).'"></a>';
                    } else {
                        echo '<a href="/login.php"><img src="/static/noava.svg"></a>';
                    }
                    ?>
                </div>
            </div>
        </header>
        <main>
            <div class="left_menu">
                <a class="link" href="/"><?=$icon['home']?> Главная</a>
                <a class="link" href="/"><?=$icon['local_fire_department']?> Популярное</a>
                <a class="link" href="/"><?=$icon['electric_bolt']?> Интересное</a>
                <a class="link" href="/"><?=$icon['favorite']?> Для вас</a>
                <a class="link" href="/"><?=$icon['search']?> Поиск</a>
                <a class="link" href="/"><?=$icon['bookmarks']?> Закладки</a>
                <?php if ($auth): ?>
                    <a class="link" href="/logout.php"><?=$icon['logout']?> Выйти</a>
                    <a class="new_post_button" href="">Новый пост</a>
                <?php else: ?>
                    <a class="new_post_button" href="/login.php">Ввойти</a>
                    <!--<a href="register.php">Регистрация</a>-->
                    <!--<a href="login.php">Вход</a>-->
                <?php endif; ?>
                <div>Категории</div>
                <div class="cat">
                    <a href=""><img src="/static/latter.php?latter=Н">Новости</a>
                    <a href=""><img src="/static/latter.php?color=2&latter=Б">Бизнес</a>
                    <a href=""><img src="/static/latter.php?color=3&latter=Р">Развлечения</a>
                    <a href=""><img src="/static/latter.php?color=4&latter=Е">Еда</a>
                    <a href=""><img src="/static/latter.php?color=5&latter=Т">Туризм</a>
                    <a href="">Еще..</a>
                </div>
                <span class="copy">Этот сайт работает на SwiftCMS. Свободный код – свободный мир!</span>
            </div>
            <div class="content">